from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, Directory

Amptk_Illumina3_V0_1_0 = CommandToolBuilder(tool="amptk_illumina3", base_command=["amptk", "illumina3"], inputs=[ToolInput(tag="in_forward", input_type=Boolean(optional=True), prefix="--forward", doc=InputDocumentation(doc="FASTQ R1 (forward) file (Required)")), ToolInput(tag="in_reverse", input_type=Boolean(optional=True), prefix="--reverse", doc=InputDocumentation(doc="FASTQ R2 (reverse) file (Required)")), ToolInput(tag="in_index", input_type=Boolean(optional=True), prefix="--index", doc=InputDocumentation(doc="FASTQ I3 (index) file (Required)")), ToolInput(tag="in_mapping_file", input_type=Boolean(optional=True), prefix="--mapping_file", doc=InputDocumentation(doc="QIIME-like mapping file.")), ToolInput(tag="in_trim_len", input_type=Boolean(optional=True), prefix="--trim_len", doc=InputDocumentation(doc="Length to trim/pad reads. Default: 300")), ToolInput(tag="in_pad", input_type=Boolean(optional=True), prefix="--pad", doc=InputDocumentation(doc="Pad reads with Ns if shorter than --trim_len. Default: off [on,off]")), ToolInput(tag="in_out", input_type=Directory(optional=True), prefix="--out", doc=InputDocumentation(doc="Output folder name. Default: amptk-data")), ToolInput(tag="in_fwd_primer", input_type=Boolean(optional=True), prefix="--fwd_primer", doc=InputDocumentation(doc="Forward primer sequence")), ToolInput(tag="in_rev_primer", input_type=Boolean(optional=True), prefix="--rev_primer", doc=InputDocumentation(doc="Reverse primer sequence")), ToolInput(tag="in_min_len", input_type=Boolean(optional=True), prefix="--min_len", doc=InputDocumentation(doc="Minimum length read to keep. Default: 100")), ToolInput(tag="in_read_length", input_type=Boolean(optional=True), prefix="--read_length", doc=InputDocumentation(doc="Illumina Read length (250 if 2 x 250 bp run). Default: auto detect")), ToolInput(tag="in_rescue_forward", input_type=Boolean(optional=True), prefix="--rescue_forward", doc=InputDocumentation(doc="Rescue Forward Reads if PE do not merge, e.g. long amplicons. Default: on [on,off]")), ToolInput(tag="in_barcode_fast_a", input_type=Boolean(optional=True), prefix="--barcode_fasta", doc=InputDocumentation(doc="Multi-fasta file of barocdes.")), ToolInput(tag="in_primer_mismatch", input_type=Boolean(optional=True), prefix="--primer_mismatch", doc=InputDocumentation(doc="Number of mismatches in primers to allow. Default: 2")), ToolInput(tag="in_barcode_mismatch", input_type=Boolean(optional=True), prefix="--barcode_mismatch", doc=InputDocumentation(doc="Number of mismatches in index (barcodes) to allow. Default: 2")), ToolInput(tag="in_barcode_rev_comp", input_type=Boolean(optional=True), prefix="--barcode_rev_comp", doc=InputDocumentation(doc="Reverse complement barcode sequences in mapping file.")), ToolInput(tag="in_merge_method", input_type=Boolean(optional=True), prefix="--merge_method", doc=InputDocumentation(doc="Software to use for PE merging. Default: usearch [usearch,vsearch]")), ToolInput(tag="in_cpus", input_type=Boolean(optional=True), prefix="--cpus", doc=InputDocumentation(doc="Number of CPUs to use. Default: all")), ToolInput(tag="in_cleanup", input_type=Boolean(optional=True), prefix="--cleanup", doc=InputDocumentation(doc="Remove intermediate files.")), ToolInput(tag="in_u_search", input_type=Boolean(optional=True), prefix="--usearch", doc=InputDocumentation(doc="USEARCH executable. Default: usearch9"))], outputs=[ToolOutput(tag="out_out", output_type=Directory(optional=True), selector=InputSelector(input_to_select="in_out", type_hint=File()), doc=OutputDocumentation(doc="Output folder name. Default: amptk-data"))], container="quay.io/biocontainers/amptk:1.5.1--py_1", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Amptk_Illumina3_V0_1_0().translate("wdl")

